/*! grafana - v2.5.0 - 2015-11-02
 * Copyright (c) 2015 Torkel Ödegaard; Licensed Apache-2.0 */

define(["angular","lodash","./queryCtrl","./modalCtrl","./directives"],function(a,b){"use strict";var c=a.module("grafana.services");c.factory("OpenNMSDatasource",["$q","$http","templateSrv",function(a,c,d){function e(a){this.type="opennms",this.url=a.url,this.name=a.name,this.basicAuth=a.basicAuth,this.withCredentials=a.withCredentials,this.searchLimit=25,this.supportMetrics=!0}function f(a,b,c){return b().then(void 0,function(d){0!==d.status||d.status>=300?(d.message="OpenNMS Error: <br/>"+d.data,a.reject(d)):setTimeout(function(){return f(a,b,Math.min(2*c,3e4))},c)})}function g(a,c){return b.each(a,function(a){void 0!==a.rrdGraphAttributes&&Object.keys(a.rrdGraphAttributes).length>0&&c.push(a),void 0!==a.children&&a.children.resource.length>0&&g(a.children.resource,c)}),c}return e.prototype.query=function(b){var c,d=this,e=d._buildQuery(b);return e.source.length>0?c=this._onmsRequest("POST","/rest/measurements",e):(c=a.defer(),c.resolve({measurements:[]})),a.when(c).then(function(a){return d._processResponse(a)})},e.prototype.testDatasource=function(){return this._onmsRequest("GET","/rest/info").then(function(){return{status:"success",message:"Data source is working",title:"Success"}})},e.prototype._buildQuery=function(a){var c=this,d=a.range.from.valueOf(),e=a.range.to.valueOf(),f=Math.floor((e-d)/a.maxDataPoints),g={start:d,end:e,step:f,maxrows:a.maxDataPoints,source:[],expression:[]};return b.each(a.targets,function(a){var d="false";if(a.hide&&(d=!0),"attribute"===a.type){if(!(a.nodeId&&a.resourceId&&a.attribute))return;var e=a.label;(void 0===e||""===e)&&(e=a.attribute);var f={aggregation:a.aggregation,attribute:a.attribute,label:e,resourceId:c._getRemoteResourceId(a.nodeId,a.resourceId),"transient":d};g.source=g.source.concat(c._interpolateSourceVariables(f))}else if("expression"===a.type){if(!a.label||!a.expression)return;var h={label:a.label,value:a.expression,"transient":d};g.expression=g.expression.concat(c.__interpolateExpressionVariables(h))}else if("filter"===a.type){if(!a.filter)return;var i=[];b.each(a.filterParameters,function(a,b){void 0!==a&&""!==a&&null!==a&&i.push({key:b,value:a})});var j={name:a.filter.name,parameter:i};g.filter=g.filter?g.filter.concat(j):[j]}}),g},e.prototype._interpolateSourceVariables=function(a){return this.__interpolateVariables(a,["resourceId","attribute","label"])},e.prototype.__interpolateExpressionVariables=function(a){return this.__interpolateVariables(a,["value","label"])},e.prototype.__interpolateVariables=function(a,c){var e=[];if(b.each(d.variables,function(f){var g=b.find(c,function(b){return d.containsVariable(a[b],f.name)});g&&e.push(f)}),0===e.length)return[a];var f=this._cartesianVariables(e),g=[];return b.each(f,function(e){var f={};b.each(e,function(a){f[a.name]={value:a.current.value}});var h=b.clone(a);b.each(c,function(a){h[a]=d.replace(h[a],f)}),g.push(h)}),g},e.prototype._cartesianVariables=function(a){var c=[];b.each(a,function(a){var d;d=b.isString(a.current.value)?[a.current.value]:a.current.value,c.push(d)});var d=this._cartesian(c),e=[];return b.each(d,function(b){for(var c=[],d=0,f=a.length;f>d;d++){var g=JSON.parse(JSON.stringify(a[d]));g.current.value=b[d],c.push(g)}e.push(c)}),e},e.prototype._cartesian=function(a){function b(e,f){for(var g=0,h=a[f].length;h>g;g++){var i=e.slice(0);i.push(a[f][g]),f===d?c.push(i):b(i,f+1)}}var c=[],d=a.length-1;return b([],0),c},e.prototype._processResponse=function(a){var b,c,d,e,f,g=a.labels,h=a.columns,i=a.timestamps,j=[];if(void 0!==i)for(d=i.length,e=h.length,b=0;e>b;b++){for(f=[],c=0;d>c;c++)i[c]<a.start||i[c]>a.end||f.push([h[b].values[c],i[c]]);j.push({target:g[b],datapoints:f})}return{data:j}},e.prototype._onmsRequest=function(d,e,g){var h=this,i=a.defer();return f(i,function(){var a={};"GET"===d&&(b.extend(a,g),g=null);var f={method:d,url:h.url+e,params:a,data:g};return(h.basicAuth||h.withCredentials)&&(f.withCredentials=!0),h.basicAuth&&(f.headers=f.headers||{},f.headers.Authorization=h.basicAuth),c(f).success(function(a){i.resolve(a)})},10),i.promise},e.prototype.getResourcesWithAttributesForNode=function(a){return this._onmsRequest("GET","/rest/resources/fornode/"+encodeURIComponent(a),{depth:-1}).then(function(a){return g([a],[])})},e.prototype._getRemoteResourceId=function(a,b){var c="";return c=a.indexOf(":")>0?"nodeSource[":"node[",c+a+"]."+b},e.prototype.suggestAttributes=function(a,c,d){return this._onmsRequest("GET","/rest/resources/"+encodeURIComponent(this._getRemoteResourceId(a,c)),{depth:-1}).then(function(a){d=d.toLowerCase();var c=[];return b.each(a.rrdGraphAttributes,function(a,b){b.toLowerCase().indexOf(d)>=0&&c.push(b)}),c.sort(),c})},e.prototype.searchForNodes=function(a){var b=this;return this._onmsRequest("GET","/rest/nodes",{limit:b.searchLimit,match:"any",comparator:"ilike",orderBy:"id",order:"asc",label:"%"+a+"%",sysName:"%"+a+"%","ipInterface.ipAddress":"%"+a+"%","ipInterface.ipHostName":"%"+a+"%",foreignId:a+"%"})},e.prototype.getAvailableFilters=function(){return this._onmsRequest("GET","/rest/measurements/filters").then(function(a){return a})},e}])});